; =======================================================================================================
; V2FLO / COPY VDK TO DISK
; This dweeb will be loaded by DLOAD this way:
; DLOAD"V2FLO""DiskName.VDK"
; It will copy the VDK to the disk inserted into the default Dragon drive
; It checks the VDK image to verify that it will fit in the mounted disk on the physical default drive 
; It asks DW4 to send packs of 90 sectors (5 tracks x 18 sectors each), saves them to memory and later to disk
; It copies either DOS disks as well as OS-9 or NitrOS-9 ones.
; it will add the .VDK extension if none is present in the command line
; =======================================================================================================
;							      Normal   Double  High_Density  Special_Double
;           Kbytes	       180       360       720				360
;
; Header    Tracks (8)	     40			40			 80				 80
; VDK data  Sides	 (9)        1			 2			  2				  1
;
; Floppy    Tracks (252)     40        40        80				 80
; Dirdata	Sectors(253)     18        36        36				 18
;
; =======================================================================================================
; Trying to substitute the call to $C104 by a call to ($C028) requires more code to get the right LSN!
; If code block to "Update working DOS variables" is omitted, then it doesn't write to floppy!
; =======================================================================================================
       ORG   $1800
       PUT   $1800
;
DNUM   EQU   $12							; assigned drive number by DW4 server
SEC1ST EQU   $76							; 1ST sector number to receive-save in a pack (2 Bytes) - (1-2880) 
CURPOS EQU   $88							; actual cursor position
TOTSEC EQU   $E6							; total number of tracks to be copied (2 bytes) - (720-2880) 
WRKDRV EQU   $EB							; drive for the command to be executed
WRKTRK EQU   $EC							; track to access
WRKSEC EQU   $ED							; sector to be accessed
WRKBUF EQU   $EE							; buffer where data is to be put (2 bytes)
numsec equ	 $F7							; number of sectors x track
MOTTIM EQU   $0605                  ; motor timer
DEFDRV EQU   $060A                  ; default floppy drive number
DRVINF EQU   $0616                  ; base to Drive info    (D1: $61C - D2: $622 - D3: $628 - D4: $62E  step = +6)
DRVGEO EQU   $06A6						; base to sectors/track (D1: $6A7 - D2: $6A8 - D3: $6A9 - D4: $6AA  step = +1)
;
DIMASK EQU   $50							; mask to disable interrupts(FIRQ and IRQ)
EIMASK EQU   $AF                    ; mask to enable interrupts
NAMBUF EQU   $1D1							; fixed by BASIC, read filename function which stores in $1d1
HEADER EQU   $1B00                  ; place where header (sector zero) is to be loaded (1B00-1BFF)
RAMINI EQU   $1C00						; where to copy the 90 data sectors of each pack
RAMMAX EQU   $75FF						; RAM limit to be filled (23,040KB = 90 sectors)
FLODIR EQU   $7600                  ; Area where sector 1 of drive directory will be read
;
SYSERR EQU   $8344						; Show error message (B=error code)
WAITKY EQU   $852B                  ; wait for a key
OUTSTR EQU   $90E5						; print string at X+1 to DEVNUM
OUTNUM EQU   $957A			         ; print number in D to DEVNUM
OUTCHR EQU   $B54A					   ; print char at reg 'A' to DEVNUM
GETNAM EQU   $B7AA						; read file name and length into $1d1
IOERR  EQU   $B84B						; IO ERROR message
FWRSEC EQU   $C028                  ; write a sector to disk from user buffer
FRDSEC EQU   $C104                  ; read a sector from disk to user buffer
;
ENTRY  BSR   MSG01 					   ; print initial message
       LDX   ,S							; get stack pointer ro reg 'X'
       LDU   1,X							; get 1ST address from vector table
       STU   DWRVEC  					; save as vector for DWREAD
       LDU   3,X							; get 2nd address from vector table
       STU   DWWVEC						; save as vector for DWWRITE
       LDU   5,X							; get 3rd address from vector table
       STU   DWDVEC						; save as vector for DWDOREAD
;
GETN   ORCC  #DIMASK	            	; disable FIRQ, IRQ (to work with DW4)
		 JSR   GETNAM						; read VDK file name and length into $1d1 = nambuf
       LDX   #NAMBUF-1					; byte before packet buffer start
       CLR   ,X							; zero MSB to make a 16 bit value for Y
       LDY   ,X++							; length of file name (16 bit)
       BEQ   FAILED						; if len=0 no file entered
       LDB   -1,X							; length of name (8 bit)
;											; Adding .VDK if not termination entered
		 PSHS  B,X							; save pointer to beginning of name and name length
ISDOT  LDA   ,X+							; get a char from name
       CMPA  #'.							; is it a dot?
       BEQ   ALRDOT						; yes, stop search, quit loop
       DECB									; decrement counter
       BNE   ISDOT						; not end of string, get next char name
       LDD   #$2E56						; get chars ".V"
       STD   ,X++							; add to end of name
       LDD   #$444B						; get chars "DK"
       STD   ,X++							; add to end of name
		 LDB   ,S							; get old name length
		 ADDB  #4							; add 4 (because of .VDK added)
		 STB   ,S							; update new length in stack
       STB   NAMBUF						; save new length in byte before string
       LEAY  4,Y                    ; correction to name length - DW parameter
ALRDOT PULS  B,X       					; restore pointer and length
       CLR   B,X							; zero terminate name string (for error)
       INC   ,--X							; 1 = DriveWire OP_NAMEOBJ_MOUNT command
       LEAY  2,Y							; length of DW packet = name length + 2
       JSR   [DWWVEC,PCR]				; send file request to server
       LDX   #DNUM						; our drive number variable
       CLR   ,X							; clear it
       LEAY  1,Y							; read one byte back
       JSR   [DWRVEC,PCR]				; get drive number
       TST   ,X							; verify received value
       BNE   RDHEAD						; successful mount                                       
       LDB   #$19							; code for MO ERROR
	    ANDCC #EIMASK       			; enable interrupts
       JMP   SYSERR						; show error message
;										; Messages Dispatch
MSG06  LDX   #NODISK-1					; point to error message "No disk at drive"  
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG05  LDX   #NMATCH-1					; point to error message "Source-Destination differ"  
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG04  LDX   #NOTDW-1					; point to error message "Not DW-adapted file"
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG03  LDX   #NOTVDK-1					; point to error message "Not VDK file"  
    	 ANDCC #EIMASK       			; enable interrupts
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG02	 LDX   #INSERT-1					; point to message asking for a floppy
		 FCB   #$10							; forms LDY #xxxx with next instruction, to jump it
MSG01  LDX   #LDTEXT-1					; point to intro message
       JSR   OUTSTR						; print message to screen
		 RTS									; return
;
FAILED ANDCC  #EIMASK       			; enable interrupts
    	 JMP   IOERR						; I/O error message
;										; Analyze VDK header
RDHEAD LDX   #1							; first data sector to be read through DW4
       STX   <SEC1ST						; save into variable
       LEAX  -1,X							; header sector is number zero
       LDY   #HEADER						; point to header read area
       JSR   [DWDVEC,PCR]				; read header
       BCS   FAILED						; detect frame error
       BNE   FAILED						; detect incomplete read operation
       LDD   #$646B                 ; first word (byte numbers 0-1) should be 'dk' (lowercase)
       CMPD  ,Y                     ; is a VDK file?
       BNE   MSG03				      ; no, show error (Not an VDK file)
		 LDB   2,Y  						; header length. Low 8 bits come in byte 2
		 LDA   3,Y                    ; header length. High 8 bits come in byte 3
		 CMPD	 #$0100						; is it a DW-adapted VDK?
       BNE   MSG04						; no, show error (Not DW-adapted VDK)
;										; Get geometry parameters of the VDK
VDK    LDD   8,Y							; byte number 8 is number of tracks (40=normal for 180 and 360K - 80=double for 720k)
		      								; byte number 9 is number of sides (1=single for 180K - 2=double for 360k and 720k upon byte 8)
		 CMPB  #2							; is double sided?
		 BNE   NOTX2						; no, don't double tracks
		 ASLA									; A = total number of tracks of the disk (both sides) (40 - 80 - 80 - 160)
NOTX2	 LDB	 #18                    ; number of sectors per track and side
		 MUL									; calculate total number of sectors (720 - 1440 - 1440 - 2880)
		 STD   <TOTSEC						; save number of sectors to be copied
		 lda	 9,y							; get number of sides
		 ldb	 #18							; sectors per track and side
		 mul									; calculate total sectors x track
		 stb	 <numsec						; save value for later calculations
;										; Get geometry parameters of the default floppy and compare to the VDK ones
FLOPPY ANDCC #EIMASK						; enable interrupts to work with the drive
		 BSR   MSG02						; show message asking for a floppy to be put at default drive
		 JSR   WAITKY 						; wait for a key to be pressed
		 LDA   >DEFDRV						; get default drive
		 STA   <WRKDRV						; save at working actual drive
       LDD   #$1401					   ; A=20 - B=1 (directory always begins at sector 1 of track 20)
		 STD   <WRKTRK						; $EC=track (20) - $ED=sector (1)
	    LDX   #FLODIR						; point to buffer area for 1st directory sector of floppy
	    STX   <WRKBUF						; store at working buffer address for disk command
		 JSR   FRDSEC 						; read the requested disk sector
		 TSTB									; detected error reading directory?
		 BNE   MSG06						; yes, show message
		 LDX	 <WRKBUF	 					; point to the beginning of directory buffer area
		 LDD   +252,X						; A=(FLODIR+252) = number of tracks  -  B=(FLODIR+253) = number of sectors per side
		 cmpb	 <numsec						; has the same amount of sectors per track (18 - 36) - for 360k discs
		 bne	 MSG05						; no, show error
		 MUL									; total number of tracks of the floppy (720 - 1440 - 1440 - 2880)
		 CMPD  <TOTSEC						; same length as VDK?
		 LBNE   MSG05                 ; no, show error (VDK-Floppy differ)
;										; Update working DOS variables upon disk and default drive		 
		 LDA	 <numsec						; get number of sectors x track
		 LDY	 #360 						; 1st directory sector for a 180k disk
		 LDX	 <TOTSEC						; get total sectors of the disk
		 CMPX	 #720							; is a 180k disk?
		 BEQ	 DONTX2						; yes, do not double values
		 cmpx	 #2880						; is a 720K disk?
		 beq	 double						; yes, double
		 cmpa	 #18							; is it a single sided disc (360k)?
		 beq	 DONTX2						; do not double
double LDY	 #720 						; set to 1st directory sector for greater disks
DONTX2 LDU	 #DRVGEO						; point to byte before data for drive1
	    LDB   <WRKDRV						; get working drive number
	    STA	 B,U							; save number of setors at the calculated drive area
	    LDU   #DRVINF						; point to 6 bytes before data for drive1
NXTDRV LEAU  6,U							; add 6 to pointer
	    DECB									; decrement drive number
	    BNE   NXTDRV						; if not zero, keep adding 6 (next drive)
		 STY   ,U		 					; save 1st directory sector to pointed area
;										; Read packs of 90 sectors and save to disk
RDVDK  BSR	 SHOW1						; show sectors to be copied
SPIN   LDB   >MOTTIM      				; has floppy motor stopped spinning?
       BNE   SPIN        				; no, wait
       ORCC  #DIMASK						; disable interrupts to work with DW4
		 LDX   <SEC1ST						; get first sector to be read in this pack
		 LDY   #RAMINI						; point to RAM initial address  (Y = $1C00)
RDLOOP JSR   [DWDVEC,PCR]				; read sector (into Y) 				
       LBCS  FAILED						; detect frame error
       LBNE  FAILED						; detect incomplete read operation
       LEAX  1,X							; next sector number
       LEAY  256,Y						; point to next sector address in RAM
       CMPY  #RAMMAX						; got to the RAM limit?	(Y > $75FF)
       BLO   RDLOOP						; no, keep on reading sectors from the VDK
       ANDCC #EIMASK						; enable interrupts to work with drive
		 BSR   SAVBLK                 ; write the pack at RAM to floppy
		 STX   <SEC1ST						; save first sector for next pack
		 CMPX  <TOTSEC                ; copied the whole VDK?
       BLO   RDVDK                  ; no, go process next pack
    	 ANDCC #EIMASK       			; enable interrupts
       RTS									; return to the caller
;												; messages to show program progress
SHOW1  LDX   #BEGIN-1					; point to message prior to read sectors
		 FCB   #$10							; byte to jump over next instruction, gives LDY #xxxx
SHOW2	 LDX   #DONE-1						; point to message post reading sectors
   	 JSR   OUTSTR						; show message
   	 LDX	 #TEXT1-1					; point to common message part 1
		 JSR	 OUTSTR						; show message
		 LDD   <SEC1ST						; get first loaded sector
		 subd	 #0001						; in order to use the same numbers than FLO2V
		 JSR   OUTNUM						; print it to screen
		 LDX	 #TEXT2-1					; point to numbers separator
		 JSR	 OUTSTR						; show message
		 LDD   <SEC1ST						; get first loaded sector
		 ADDD  #88							; add 88 to get last one loaded. Was 89 but now mimics the numbers as FLO2V
		 JSR	 OUTNUM						; print it to screen
		 LDA	 #$0D							; get ASCII for CR
		 JSR	 OUTCHR						; print to screen
		 RTS									; return
;----------------------------------------------------------------------------------------
; Saves 90 sectors with data pointed by 'X'. 1st sector LSN in 'Y' (no parameters needed
;----------------------------------------------------------------------------------------
SAVBLK PSHS  X 							; save 1st sector numer for next pack
		 LDY   <SEC1ST   				   ; get 1st sector to be saved
		 LEAY	 -1,Y							; LSN begins from 0 to 719 - 1439 - 2879 (but we read from 1 to n)
       LDX   #RAMINI      				; beginning of RAM data received
       LDA   #90        				; number of sectors to save in a pack
GRABLK PSHS  A,Y          				; save control registers
												; it seems that DosPlus4.9 needs the total sectors x track to be updated here
		 lda	 <numsec						; A should get here 18 for single sided or 36 for double sided disks
       LDU	 #DRVGEO						; point to byte before data for drive1
	    LDB   <WRKDRV						; get working drive number
	    STA	 B,U							; save number of sectors at the calculated drive area
       JSR   [FWRSEC]     				; write 1 sector to floppy
       PULS  A,Y          				; retrieve control registers
       LEAX  +256,X       				; point to next sector in RAM buffer
       LEAY  1,Y          				; increment LSN (next sector)
       DECA               				; decrement sector counter
       BNE   GRABLK       				; if not yet finished, keep on saving to floppy
       LDD   <CURPOS						; get current cursor position
       SUBD	 #32							; go one row up
       STD   <CURPOS						; save new position. Next message will overlap last one
		 BSR	 SHOW2						; show sectors just copied
       PULS  X,PC 						; end of save block
;
LDTEXT FCC   /COPY VDK/,13,0		   ; intro message to the user
INSERT FCC   /INSERT DISK AT /
		 FCC   /DEFAULT DRIVE/,13
		 FCC   /PRESS A KEY/,13,0		; ask for a floppy
NOTVDK FCC   /NOT AN VDK FILE/,0		; bad VDK file
NOTDW  FCC   /VDK NOT FOR DW/,0		; VDK not adapted for DW
NMATCH FCC   /VDK-DISK DIFFER/,0		; VDK - Floppy sizes don't match
NODISK FCC   /NO DISK FOUND/,0      ; No disk or not formatted
BEGIN  FCC   / COPY/,0					; before copying a block
DONE   FCC   /saved/,0					; after saving the block
TEXT1  FCC   / SECTORS: /,0		   ; fixed text
TEXT2  FCC   / - /,0						; separator
;
DWRVEC FDB   0								; indirect jump to drivewire read function
DWWVEC FDB   0								; indirect jump to drivewire write function 
DWDVEC FDB   0								; indirect jump to drivewire doread function
; 
;----------------------------------------------------------------------------------------
		 IF ((*+9)%256 > 0)
		    rzb	 256-((*+9)%256)		; make it DW4 compatible (length multiple of 256 bytes)
		 ENDIF
;----------------------------------------------------------------------------------------
